/*==============================================================*
 *
 *	slips.h
 *
 *==============================================================*/

#ifndef _SLIPS_H_
#define _SLIPS_H_

#include "config.h"

struct option;

/*
 * Functions
 */
int	slips_init(Tcl_Interp *interp);
int	tcl_getopt(Tcl_Interp *interp, struct option *table, 
			int argc, char *argv[], int *optind);

/*
 * TTY handling
 */
int	tty_all(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	tty_chat(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	tty_close(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	tty_expect(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	tty_flush(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	tty_hangup(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	tty_lock(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	tty_open(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	tty_recv(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	tty_send(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	tty_unlock(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);

/*
 * NET handling
 */
int	net_all(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	net_slip(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	net_ifstats(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	net_iflist(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);

/*
 * signal handling
 */
int	sys_all(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	sys_fork(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	sys_kill(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	sys_pause(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	sys_signal(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	sys_sleep(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);
int	sys_time(ClientData cd, Tcl_Interp *interp, int argc, char *argv[]);

int	sys_sigchat(void); /* hack */


/*
 * TCL options parsing...
 */
struct option {
	char	*name;		/* option name minus leading '-' */
	char	type;		/* option type (see below)	 */
	void	*argp;		/* where to store argument value */
};

typedef struct opt_multi {	/* struct to cope with options that	*/
	int	max, count;	/* may be specified more than once	*/
	void	*array;
} opt_multi;

#define	T_VOID		0
#define	T_TRUE		1
#define	T_FALSE		2
#define	T_INT		3
#define	T_STRING	4
#define	T_BOOL		T_TRUE
#define T_SCALAR	31
#define	T_MULTI		32

#endif /* _SLIPS_H_ */
